// VCppExportExample.cpp : Implementation of DLL Exports.


#include "stdafx.h"
#include "resource.h"
#include "VCppExportExample_i.h"
#include "dllmain.h"

#define PLUGIN_KEY "SOFTWARE\\Dewesoft\\Exports\\VCppExportExample"

using namespace ATL;


void WriteDewesoftReg()
{
 HKEY hKey;
 DWORD disposition;
 
 RegCreateKeyEx(HKEY_LOCAL_MACHINE, TEXT(PLUGIN_KEY), 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &disposition);
 
 LPCTSTR RegName = TEXT("VCpp Export Example (*.txt)");
 LPCTSTR RegVendor = TEXT("Dewesoft");
 LPCTSTR RegVersion = TEXT("1.0.0");
 LPCTSTR RegDescription = TEXT("Visual C++ export example");
 LPCTSTR RegExtension = TEXT("txt");
 LPOLESTR lpoleGuid;
 StringFromCLSID(CLSID_VCppExportImpl, &lpoleGuid);
 
 RegSetValueEx(hKey, TEXT("Name"), 0, REG_SZ, (LPBYTE)RegName, _tcslen(RegName) * sizeof(TCHAR));
 RegSetValueEx(hKey, TEXT("Extension"), 0, REG_SZ, (LPBYTE)RegExtension, _tcslen(RegExtension) * sizeof(TCHAR));
 RegSetValueEx(hKey, TEXT("Vendor"), 0, REG_SZ, (BYTE*)RegVendor, _tcslen(RegVendor) * sizeof(TCHAR));
 RegSetValueEx(hKey, TEXT("Version"), 0, REG_SZ, (BYTE*)RegVersion, _tcslen(RegVersion) * sizeof(TCHAR));
 RegSetValueEx(hKey, TEXT("Description"), 0, REG_SZ, (BYTE*)RegDescription, _tcslen(RegDescription) * sizeof(TCHAR));
 RegSetValueEx(hKey, TEXT("GUID"), 0, REG_SZ, (BYTE*)lpoleGuid, _tcslen(lpoleGuid) * sizeof(TCHAR));
 
 RegCloseKey(hKey);
}

// Used to determine whether the DLL can be unloaded by OLE.
STDAPI DllCanUnloadNow(void)
{
		return _AtlModule.DllCanUnloadNow();
}

// Returns a class factory to create an object of the requested type.
STDAPI DllGetClassObject(_In_ REFCLSID rclsid, _In_ REFIID riid, _Outptr_ LPVOID* ppv)
{
		return _AtlModule.DllGetClassObject(rclsid, riid, ppv);
}

// DllRegisterServer - Adds entries to the system registry.
STDAPI DllRegisterServer(void)
{
	 WriteDewesoftReg();

	// registers object, typelib and all interfaces in typelib
	HRESULT hr = _AtlModule.DllRegisterServer();
		return hr;
}

// DllUnregisterServer - Removes entries from the system registry.
STDAPI DllUnregisterServer(void)
{
	RegDeleteKey(HKEY_LOCAL_MACHINE, TEXT(PLUGIN_KEY));

	HRESULT hr = _AtlModule.DllUnregisterServer();
		return hr;
}

// DllInstall - Adds/Removes entries to the system registry per user per machine.
STDAPI DllInstall(BOOL bInstall, _In_opt_  LPCWSTR pszCmdLine)
{
	HRESULT hr = E_FAIL;
	static const wchar_t szUserSwitch[] = L"user";

	if (pszCmdLine != NULL)
	{
		if (_wcsnicmp(pszCmdLine, szUserSwitch, _countof(szUserSwitch)) == 0)
		{
			ATL::AtlSetPerUserRegistration(true);
		}
	}

	if (bInstall)
	{	
		hr = DllRegisterServer();
		if (FAILED(hr))
		{
			DllUnregisterServer();
		}
	}
	else
	{
		hr = DllUnregisterServer();
	}

	return hr;
}


