// VCppExportImpl.cpp : Implementation of CVCppExportImpl

#include "stdafx.h"
#include "VCppExportImpl.h"
#include <comutil.h>
#include <stdio.h>
#include <math.h>


// CVCppExportImpl

STDMETHODIMP CVCppExportImpl::StartExport(IApp * App)
{
	exp_file.open(exp_file_name);
	return S_OK;
}

STDMETHODIMP CVCppExportImpl::get_ExportType(ExportTypes * Value)
{
	*Value = etValueBased;
	return S_OK;
}

STDMETHODIMP CVCppExportImpl::get_SupportsAsync(VARIANT_BOOL * Value)
{
	*Value = true;
	return S_OK;
}

STDMETHODIMP CVCppExportImpl::StartInfo(BSTR Info)
{
	exp_file << "File header:" << endl;
	return S_OK;
}

STDMETHODIMP CVCppExportImpl::EndExport()
{
	exp_file.close();
	return S_OK;
}

STDMETHODIMP CVCppExportImpl::put_FileName(BSTR Value)
{
	exp_file_name = _com_util::ConvertBSTRToString(Value);
	return S_OK;
}

STDMETHODIMP CVCppExportImpl::WriteInfoString(BSTR Description, BSTR Value)
{
	char* desc = _com_util::ConvertBSTRToString(Description);
	char* val = _com_util::ConvertBSTRToString(Value);

	if ((val != NULL) && (desc != NULL))
		exp_file << desc << ": " << val << endl;

	return S_OK;
}

STDMETHODIMP CVCppExportImpl::StartDataFolder(BSTR FolderName, DATE AbsTime)
{
	exp_file << endl << "Trigger..." << endl << endl;
	return S_OK;
}

STDMETHODIMP CVCppExportImpl::StartEvents()
{
	exp_file << endl << "Event list:" << endl;
	return S_OK;
}

STDMETHODIMP CVCppExportImpl::StopEvents()
{
	exp_file << "End events." << endl;
	return S_OK;
}

STDMETHODIMP CVCppExportImpl::WriteEvent(long EventType, BSTR EventTypeString, double Time, BSTR Comment)
{
	char* event_type = _com_util::ConvertBSTRToString(EventTypeString);
	char stime[30];
	sprintf_s(stime, 30, "%f", Time);
	if (event_type != NULL)
		exp_file << "Event type: " << event_type << ", Time: " << stime << endl;

	return S_OK;
}

STDMETHODIMP CVCppExportImpl::StartTimeField(BSTR FieldName, BSTR FieldUnit)
{
	char* sfieldname = _com_util::ConvertBSTRToString(FieldName);
	if (sfieldname != NULL)
		exp_file << sfieldname << "\t";

	return S_OK;
}

STDMETHODIMP CVCppExportImpl::StartDataField(BSTR FieldName, BSTR FieldUnit, long ExportRate)
{
	char* sfieldname = _com_util::ConvertBSTRToString(FieldName);
	if (sfieldname != NULL)
  		exp_file << sfieldname << "\t";

	return S_OK;
}

STDMETHODIMP CVCppExportImpl::EndHeader()
{
	exp_file << endl;
	return S_OK;
}

STDMETHODIMP CVCppExportImpl::StartValue(double TimeValue)
{
	char stime[30];
	sprintf_s(stime, 30, "%f", TimeValue);
	exp_file << stime << "\t";

	return S_OK;
}

STDMETHODIMP CVCppExportImpl::WriteValue(float Value)
{
	char sval[30];
	if (!_isnan(Value))
	{
		sprintf_s(sval, 30, "%f", Value);
		exp_file << sval;
	}

	exp_file << "\t";

	return S_OK;
}

STDMETHODIMP CVCppExportImpl::EndValue()
{
	exp_file << endl;
	return S_OK;
}

