// VCppExportImpl.h : Declaration of the CVCppExportImpl

#pragma once
#include "resource.h"       // main symbols
#include "VCppExportExample_i.h"
#include <iostream>
#include <fstream>


#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif

using namespace ATL;
using namespace std;


// CVCppExportImpl

class ATL_NO_VTABLE CVCppExportImpl :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CVCppExportImpl, &CLSID_VCppExportImpl>,
	public IDispatchImpl<IVCppExportImpl, &IID_IVCppExportImpl, &LIBID_VCppExportExampleLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public ICustomExport,
	public ICustomExport2,
	public IDispatchImpl<ICustomExport3, &__uuidof(ICustomExport3), &LIBID_DEWEsoft, /* wMajor = */ 630, /* wMinor = */ 7>,
	public IDispatchImpl<IExportFrame, &__uuidof(IExportFrame), &LIBID_DEWEsoft, /* wMajor = */ 630, /* wMinor = */ 7>
{
private:
	IApp* app;
	bool used;
	ofstream exp_file;
	char* exp_file_name;

public:
	CVCppExportImpl()
	{
	}

	DECLARE_REGISTRY_RESOURCEID(IDR_VCPPEXPORTIMPL)


	BEGIN_COM_MAP(CVCppExportImpl)
		COM_INTERFACE_ENTRY(IVCppExportImpl)
		COM_INTERFACE_ENTRY2(IDispatch, IVCppExportImpl)
		COM_INTERFACE_ENTRY(ICustomExport)
		COM_INTERFACE_ENTRY(ICustomExport2)
		COM_INTERFACE_ENTRY(ICustomExport3)
		COM_INTERFACE_ENTRY(IExportFrame)
	END_COM_MAP()



	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}

	// ICustomExport Methods
public:
	STDMETHOD(get_FileName)(BSTR * Value)
	{
		return S_OK;
	}
	STDMETHOD(put_FileName)(BSTR Value);
	STDMETHOD(StartExport)(IApp * App);	
	STDMETHOD(EndExport)();
	STDMETHOD(get_ExportType)(ExportTypes * Value);
	STDMETHOD(get_AbsoluteTime)(VARIANT_BOOL * Value)
	{
		return S_OK;
	}
	STDMETHOD(put_AbsoluteTime)(VARIANT_BOOL Value)
	{
		return S_OK;
	}
	STDMETHOD(StartDataFolder)(BSTR FolderName, DATE AbsTime);
	STDMETHOD(EndDataFolder)()
	{
		return S_OK;
	}
	STDMETHOD(StartInfo)(BSTR Info);
	STDMETHOD(WriteInfoString)(BSTR Description, BSTR Value);
	STDMETHOD(WriteInfoInteger)(BSTR Description, long Param)
	{
		return S_OK;
	}
	STDMETHOD(WriteInfoSingle)(BSTR Description, float Value)
	{
		return S_OK;
	}
	STDMETHOD(WriteInfoDate)(BSTR Description, DATE Value)
	{
		return S_OK;
	}
	STDMETHOD(EndInfo)()
	{
		return S_OK;
	}
	STDMETHOD(StartTimeField)(BSTR FieldName, BSTR FieldUnit);
	STDMETHOD(StartDataField)(BSTR FieldName, BSTR FieldUnit, long ExportRate);
	STDMETHOD(EndHeader)();
	STDMETHOD(StartValue)(double TimeValue);
	STDMETHOD(StartAbsValue)(DATE DateTime)
	{
		return S_OK;
	}
	STDMETHOD(WriteValue)(float Value);
	STDMETHOD(WriteAsyncValue)(double TimeStamp, float Value)
	{
		return S_OK;
	}
	STDMETHOD(StartChannel)(BSTR FieldName, BSTR FieldUnit, VARIANT_BOOL Async)
	{
		return S_OK;
	}
	STDMETHOD(get_Extension)(BSTR * Value)
	{
		return S_OK;
	}
	STDMETHOD(get_TimeIncrease)(double * Value)
	{
		return S_OK;
	}
	STDMETHOD(put_TimeIncrease)(double Value)
	{
		return S_OK;
	}
	STDMETHOD(EndChannel)()
	{
		return S_OK;
	}
	STDMETHOD(EndValue)();
	STDMETHOD(get_SupportsAsync)(VARIANT_BOOL * Value);
	STDMETHOD(get_SupportsSRDiv)(VARIANT_BOOL * Value)
	{
		return S_OK;
	}
	STDMETHOD(get_DataCount)(unsigned __int64 * Value)
	{
		return S_OK;
	}
	STDMETHOD(put_DataCount)(unsigned __int64 Value)
	{
		return S_OK;
	}

	// ICustomExport2 Methods
public:
	STDMETHOD(SetAbsMin)(float AbsMin)
	{
		return S_OK;
	}
	STDMETHOD(SetAbsMax)(float AbsMax)
	{
		return S_OK;
	}
	STDMETHOD(SetTrigOffset)(double TrigTime)
	{
		return S_OK;
	}
	STDMETHOD(SetChannelColor)(long Color)
	{
		return S_OK;
	}
	STDMETHOD(SetRangeMax)(float Value)
	{
		return S_OK;
	}
	STDMETHOD(SetRangeMin)(float Value)
	{
		return S_OK;
	}
	STDMETHOD(WriteDoubleValue)(double Value)
	{
		return S_OK;
	}
	STDMETHOD(WriteAsyncDoubleValue)(double TimeStamp, double Value)
	{
		return S_OK;
	}
	STDMETHOD(GetDWTypeLibVersion)(long * Value)
	{
		return S_OK;
	}
	STDMETHOD(get_SupportsDouble)(VARIANT_BOOL * Value)
	{
		return S_OK;
	}
	STDMETHOD(SetDoubleFloat)(VARIANT_BOOL DoubleFloat)
	{
		return S_OK;
	}
	STDMETHOD(StartEvents)();
	STDMETHOD(StopEvents)();
	STDMETHOD(WriteEvent)(long EventType, BSTR EventTypeString, double Time, BSTR Comment);
	STDMETHOD(SetApp)(IApp * App)
	{
		return S_OK;
	}
	STDMETHOD(SetChannel)(IChannel * Ch)
	{
		return S_OK;
	}

	// ICustomExport3 Methods
public:
	STDMETHOD(OnEvent)(CustomExpEventIDs EventIDs, VARIANT InParam, VARIANT * OutParam, HRESULT * Value)
	{
		return S_OK;
	}

	// IExportFrame Methods
public:
	STDMETHOD(ShowFrame)(long Handle, long * FrameHeight)
	{
		return S_OK;
	}
	STDMETHOD(HideFrame)()
	{
		return S_OK;
	}
	STDMETHOD(Apply)()
	{
		return S_OK;
	}
	STDMETHOD(SetExpApp)(IApp * App)
	{
		return S_OK;
	}
};

OBJECT_ENTRY_AUTO(__uuidof(VCppExportImpl), CVCppExportImpl)
